#!/bin/sh
VERSION='$Id: sm_ctrld.sh,v 2.4 2013/01/09 10:16:33 oku2 Exp $'

DEMONIZE=true

column_opt=""             # ps option to print output with nnn columns
psopts="-e -o pid,comm"
if [ "`uname`" = "Darwin" ]; then
  psopts="axw"
  if [ -n "$LAUNCHDAEMON" ]; then
    DEMONIZE=false
  fi
fi
[ "`uname`" = "FreeBSD" ] && psopts="axo"
[ "`uname`" = "Linux" ] && column_opt="--cols 132"

# READ INI
read_ini()
{
  SM_INI=`grep -i '^sm_ini=' /etc/sesam2000.ini|cut -d"=" -f2`
  echo `grep -i "$1=" "$SM_INI"|cut -d"=" -f2`
}

set_env()
{
   for e in `sed -n '/\[ENVIRONMENT]/,/^\[/p' \`grep -i '^sm_ini=' /etc/sesam2000.ini|cut -d"=" -f2\`|sed -n '/^[^#].*=/p'`
   do
      eval $e
      #export ${e%=*}
      export `echo $e|cut -d '=' -f 1`
   done
}

# KILL ACTIVE JOB
sub_kill_job()
{

  ps $psopts $column_opt | grep -v grep | grep -v `basename $MYSELF` | grep $1 >/dev/null 2>&1
  STATUS=$? 
  # no process found
  [ "$STATUS" != 0 ] && return 0
  if [ "$STATUS" = "0" ]
  then
    echo "FOUND ACTIVE ${1}. WILL REMOVE"
    ps $psopts $column_opt|grep $1|grep -v grep|grep -v `basename $MYSELF`
    ps $psopts $column_opt|grep $1|grep -v grep|grep -v `basename $MYSELF`|awk '{print $1}'|xargs -n1 kill $2
  fi
  return 1
}

# KILL ACTIVE SBC
sub_kill_sbc()
{
  sub_kill_job sbc$ -2
  if [ "$?" != "0" ]
  then
    sleep 10
    sub_kill_job sbc$ -9
  fi
}



 
# STOP OR START sm_ctrld_main
sub_env()
{
  GV_RO=/sesam/
  GV_RO=`read_ini gv_ro`

  if [ "$1" = "stop" -o "$1" = "STOP" ]
  then
    SWITCH="stop"
  else if [ "$1" = "status" -o "$1" = "STATUS" ]
  then
    SWITCH="status"
  else
    SWITCH="start"
  fi
  fi
}


# MAIN PROCEDURE
sub_main()
{
  if [ "$SWITCH" = "start" ] 
  then 
    sub_kill_sbc
    echo "TRY TO START sm_ctrld_main"
    set_env
	if $DEMONIZE; then
      nohup ${GV_RO}bin/sesam/sm_ctrld_main >/dev/null 2>&1 </dev/null &
      STATUS=$?
      if [ "$STATUS" = "0" ]
      then
        echo "DONE"
        exit 0
      else
        echo "FAIL TO START sm_ctrld_main"
        exit 1
      fi
	else
    	${GV_RO}bin/sesam/sm_ctrld_main >/dev/null 2>&1 </dev/null
		exit $?
	fi
  else
    if [ "$SWITCH" = "status" ] 
    then
      ps $psopts $column_opt | grep -v grep | grep -v `basename $MYSELF` | grep sm_ctrld_main >/dev/null 2>&1
		exit $?
    else # stop
      echo "TRY TO STOP sm_ctrld_main"
      sub_kill_sbc
      sub_kill_job sm_ctrld
      sleep 2 
      echo "DONE"
      exit 0
    fi
  fi
}

# MAIN
MYSELF=$0

# SBC ENV TIMEOUT
SBC_GEN_WAIT=1800
SBC_DATA_WAIT=1800
export SBC_GEN_WAIT
export SBC_DATA_WAIT


# RUN SUB
sub_env $1
sub_main



